﻿/// <reference path="data.js" />

(function (lightSwitchApplication) {

    var $Screen = msls.Screen,
        $defineScreen = msls._defineScreen,
        $DataServiceQuery = msls.DataServiceQuery,
        $toODataString = msls._toODataString,
        $defineShowScreen = msls._defineShowScreen;

    function AddEditChart(parameters, dataWorkspace) {
        /// <summary>
        /// Represents the AddEditChart screen.
        /// </summary>
        /// <param name="parameters" type="Array">
        /// An array of screen parameter values.
        /// </param>
        /// <param name="dataWorkspace" type="msls.application.DataWorkspace" optional="true">
        /// An existing data workspace for this screen to use. By default, a new data workspace is created.
        /// </param>
        /// <field name="Range" type="msls.application.Range">
        /// Gets or sets the range for this screen.
        /// </field>
        /// <field name="details" type="msls.application.AddEditChart.Details">
        /// Gets the details for this screen.
        /// </field>
        if (!dataWorkspace) {
            dataWorkspace = new lightSwitchApplication.DataWorkspace();
        }
        $Screen.call(this, dataWorkspace, "AddEditChart", parameters);
    }

    function BrowseCharts(parameters, dataWorkspace) {
        /// <summary>
        /// Represents the BrowseCharts screen.
        /// </summary>
        /// <param name="parameters" type="Array">
        /// An array of screen parameter values.
        /// </param>
        /// <param name="dataWorkspace" type="msls.application.DataWorkspace" optional="true">
        /// An existing data workspace for this screen to use. By default, a new data workspace is created.
        /// </param>
        /// <field name="Ranges" type="msls.VisualCollection" elementType="msls.application.Range">
        /// Gets the ranges for this screen.
        /// </field>
        /// <field name="details" type="msls.application.BrowseCharts.Details">
        /// Gets the details for this screen.
        /// </field>
        if (!dataWorkspace) {
            dataWorkspace = new lightSwitchApplication.DataWorkspace();
        }
        $Screen.call(this, dataWorkspace, "BrowseCharts", parameters);
    }

    function BrowseRangeNavicators(parameters, dataWorkspace) {
        /// <summary>
        /// Represents the BrowseRangeNavicators screen.
        /// </summary>
        /// <param name="parameters" type="Array">
        /// An array of screen parameter values.
        /// </param>
        /// <param name="dataWorkspace" type="msls.application.DataWorkspace" optional="true">
        /// An existing data workspace for this screen to use. By default, a new data workspace is created.
        /// </param>
        /// <field name="Ranges" type="msls.VisualCollection" elementType="msls.application.Range">
        /// Gets the ranges for this screen.
        /// </field>
        /// <field name="details" type="msls.application.BrowseRangeNavicators.Details">
        /// Gets the details for this screen.
        /// </field>
        if (!dataWorkspace) {
            dataWorkspace = new lightSwitchApplication.DataWorkspace();
        }
        $Screen.call(this, dataWorkspace, "BrowseRangeNavicators", parameters);
    }

    function AddEditRange(parameters, dataWorkspace) {
        /// <summary>
        /// Represents the AddEditRange screen.
        /// </summary>
        /// <param name="parameters" type="Array">
        /// An array of screen parameter values.
        /// </param>
        /// <param name="dataWorkspace" type="msls.application.DataWorkspace" optional="true">
        /// An existing data workspace for this screen to use. By default, a new data workspace is created.
        /// </param>
        /// <field name="Range" type="msls.application.Range">
        /// Gets or sets the range for this screen.
        /// </field>
        /// <field name="details" type="msls.application.AddEditRange.Details">
        /// Gets the details for this screen.
        /// </field>
        if (!dataWorkspace) {
            dataWorkspace = new lightSwitchApplication.DataWorkspace();
        }
        $Screen.call(this, dataWorkspace, "AddEditRange", parameters);
    }

    function Chart(parameters, dataWorkspace) {
        /// <summary>
        /// Represents the Chart screen.
        /// </summary>
        /// <param name="parameters" type="Array">
        /// An array of screen parameter values.
        /// </param>
        /// <param name="dataWorkspace" type="msls.application.DataWorkspace" optional="true">
        /// An existing data workspace for this screen to use. By default, a new data workspace is created.
        /// </param>
        /// <field name="Table_1" type="msls.VisualCollection" elementType="msls.application.Table_1Item">
        /// Gets the table_1 for this screen.
        /// </field>
        /// <field name="details" type="msls.application.Chart.Details">
        /// Gets the details for this screen.
        /// </field>
        if (!dataWorkspace) {
            dataWorkspace = new lightSwitchApplication.DataWorkspace();
        }
        $Screen.call(this, dataWorkspace, "Chart", parameters);
    }

    msls._addToNamespace("msls.application", {

        AddEditChart: $defineScreen(AddEditChart, [
            { name: "Range", kind: "local", type: lightSwitchApplication.Range }
        ], [
        ]),

        BrowseCharts: $defineScreen(BrowseCharts, [
            {
                name: "Ranges", kind: "collection", elementType: lightSwitchApplication.Range,
                createQuery: function () {
                    return this.dataWorkspace.ApplicationData.Ranges;
                }
            }
        ], [
        ]),

        BrowseRangeNavicators: $defineScreen(BrowseRangeNavicators, [
            {
                name: "Ranges", kind: "collection", elementType: lightSwitchApplication.Range,
                createQuery: function () {
                    return this.dataWorkspace.ApplicationData.Ranges;
                }
            }
        ], [
        ]),

        AddEditRange: $defineScreen(AddEditRange, [
            { name: "Range", kind: "local", type: lightSwitchApplication.Range }
        ], [
        ]),

        Chart: $defineScreen(Chart, [
            {
                name: "Table_1", kind: "collection", elementType: lightSwitchApplication.Table_1Item,
                createQuery: function () {
                    return this.dataWorkspace.Testdata.Table_1;
                }
            }
        ], [
        ]),

        showAddEditChart: $defineShowScreen(function showAddEditChart(Range, options) {
            /// <summary>
            /// Asynchronously navigates forward to the AddEditChart screen.
            /// </summary>
            /// <param name="options" optional="true">
            /// An object that provides one or more of the following options:<br/>- beforeShown: a function that is called after boundary behavior has been applied but before the screen is shown.<br/>+ Signature: beforeShown(screen)<br/>- afterClosed: a function that is called after boundary behavior has been applied and the screen has been closed.<br/>+ Signature: afterClosed(screen, action : msls.NavigateBackAction)
            /// </param>
            /// <returns type="WinJS.Promise" />
            var parameters = Array.prototype.slice.call(arguments, 0, 1);
            return lightSwitchApplication.showScreen("AddEditChart", parameters, options);
        }),

        showBrowseCharts: $defineShowScreen(function showBrowseCharts(options) {
            /// <summary>
            /// Asynchronously navigates forward to the BrowseCharts screen.
            /// </summary>
            /// <param name="options" optional="true">
            /// An object that provides one or more of the following options:<br/>- beforeShown: a function that is called after boundary behavior has been applied but before the screen is shown.<br/>+ Signature: beforeShown(screen)<br/>- afterClosed: a function that is called after boundary behavior has been applied and the screen has been closed.<br/>+ Signature: afterClosed(screen, action : msls.NavigateBackAction)
            /// </param>
            /// <returns type="WinJS.Promise" />
            var parameters = Array.prototype.slice.call(arguments, 0, 0);
            return lightSwitchApplication.showScreen("BrowseCharts", parameters, options);
        }),

        showBrowseRangeNavicators: $defineShowScreen(function showBrowseRangeNavicators(options) {
            /// <summary>
            /// Asynchronously navigates forward to the BrowseRangeNavicators screen.
            /// </summary>
            /// <param name="options" optional="true">
            /// An object that provides one or more of the following options:<br/>- beforeShown: a function that is called after boundary behavior has been applied but before the screen is shown.<br/>+ Signature: beforeShown(screen)<br/>- afterClosed: a function that is called after boundary behavior has been applied and the screen has been closed.<br/>+ Signature: afterClosed(screen, action : msls.NavigateBackAction)
            /// </param>
            /// <returns type="WinJS.Promise" />
            var parameters = Array.prototype.slice.call(arguments, 0, 0);
            return lightSwitchApplication.showScreen("BrowseRangeNavicators", parameters, options);
        }),

        showAddEditRange: $defineShowScreen(function showAddEditRange(Range, options) {
            /// <summary>
            /// Asynchronously navigates forward to the AddEditRange screen.
            /// </summary>
            /// <param name="options" optional="true">
            /// An object that provides one or more of the following options:<br/>- beforeShown: a function that is called after boundary behavior has been applied but before the screen is shown.<br/>+ Signature: beforeShown(screen)<br/>- afterClosed: a function that is called after boundary behavior has been applied and the screen has been closed.<br/>+ Signature: afterClosed(screen, action : msls.NavigateBackAction)
            /// </param>
            /// <returns type="WinJS.Promise" />
            var parameters = Array.prototype.slice.call(arguments, 0, 1);
            return lightSwitchApplication.showScreen("AddEditRange", parameters, options);
        }),

        showChart: $defineShowScreen(function showChart(options) {
            /// <summary>
            /// Asynchronously navigates forward to the Chart screen.
            /// </summary>
            /// <param name="options" optional="true">
            /// An object that provides one or more of the following options:<br/>- beforeShown: a function that is called after boundary behavior has been applied but before the screen is shown.<br/>+ Signature: beforeShown(screen)<br/>- afterClosed: a function that is called after boundary behavior has been applied and the screen has been closed.<br/>+ Signature: afterClosed(screen, action : msls.NavigateBackAction)
            /// </param>
            /// <returns type="WinJS.Promise" />
            var parameters = Array.prototype.slice.call(arguments, 0, 0);
            return lightSwitchApplication.showScreen("Chart", parameters, options);
        })

    });

}(msls.application));
