﻿/// <reference path="~/GeneratedArtifacts/viewModel.js" />

myapp.Chart.Table_1_render = function (element, contentItem) {
    // Write code here.
    var chartTemplate = $("<div></div>").attr('id', "chartContainer")
    var back = $("<div></div>").attr('id', "back");
    back.appendTo($(element));
    $("#back").css("left", "800px").css("top", "100px").css("border", "2px solid gray",'background-color','whitesmoke');
    chartTemplate.appendTo($(element));

    contentItem.value.oncollectionchange = function () {
        var first = contentItem.children[0];
        var xName = first.children[1].valueModel.name;
        var yName = first.children[0].valueModel.name;

        chartTemplate.ejChart(
          {
              series: [{
                  enableAnimation: true,
                  dataSource: contentItem.value.data,
                  xName: xName,
                  yName: yName,
                  type: "Line",
                  fill: '#69D2E7',
                  marker: {
                      visible: true,
                  },
                  tooltip: {
                      visible: true,
                  }
              },
              ],
              size: { height: "400" },
              legend: { visible: false },
              canResize: true
          });

        back.ejButton({
            text: "Load Chart",
            click: "displayResult",
            height: 25,
            width: 70
        });
    }
};


function displayResult() {
    intervalId = window.setInterval(OnRefresh, 1000);

}


function OnRefresh() {

    var chartobj = $("#chartContainer").ejChart("instance");
    chartobj.model.series[0].dataSource = null;
    chartobj.model.series[0].xName = null;
    chartobj.model.series[0].yName = null;
    if (chartobj.model.series[0].points.length > 10) {
        chartobj.model.series[0].points.splice(0, 2);
    }
    AddPoint(chartobj.model.series[0]);
    
    $("#chartContainer").ejChart("redraw");
}

// Chart has been redrawn to this method

function AddPoint(series) {
    if (series.points == undefined)
        series.points = [];
    var da = new Date(series.points[series.points.length -1].x);
    var dateVal = new Date(da.setDate(da.getDate() + 1));
    var rn = parseInt(getRandomInt(20,50));
    series.points[series.points.length] = { x: dateVal, y: rn };
    $.ajax({
        type: "POST",
        url: "../../web/WebForm1.aspx/LiveData",
        data: JSON.stringify({ "date": dateVal, "val": rn }),
        contentType: "application/json; charset=utf-8",
        dataType: 'json',
        success: function (data) {
            console.log('success', data);

        },
        error: function (jqXHR, textStatus, errorThrown) {
            alert('Exeption:' + errorThrown);
        }
    });
}

function getRandomInt(min, max) {
    return Math.floor(Math.random() * (max - min + 1)) + min;
}